import bpy
from bpy.props import StringProperty, BoolProperty, EnumProperty, CollectionProperty, IntProperty, FloatProperty, PointerProperty
from bpy_types import PropertyGroup
from .utilities import init_previews

class CrowdItem(PropertyGroup):
    perso: StringProperty(
        default = 'Andre'
    )
    anim: StringProperty(
        default = 'Run'
    )

class POPULATION_Props(PropertyGroup):
    def single_toggle(self, context):
        if not bpy.context.scene.POPULATION_Props.inib:
            bpy.context.scene.POPULATION_Props.inib =True
            if bpy.context.scene.POPULATION_Props.single:
                bpy.context.scene.POPULATION_Props.crowd = False
            else:
                bpy.context.scene.POPULATION_Props.crowd = True
            init_previews(force=True, what='ANIM')
            bpy.context.scene.POPULATION_Props.inib = False

    def crowd_toggle(self, context):
        if not bpy.context.scene.POPULATION_Props.inib:
            bpy.context.scene.POPULATION_Props.inib =True
            if bpy.context.scene.POPULATION_Props.crowd:
                bpy.context.scene.POPULATION_Props.single = False
            else:
                bpy.context.scene.POPULATION_Props.single = True
            init_previews(force=True, what='ANIM')
            bpy.context.scene.POPULATION_Props.inib = False

    def walk_toggle(self, context):
        if not bpy.context.scene.POPULATION_Props.inib:
            bpy.context.scene.POPULATION_Props.inib =True
            if bpy.context.scene.POPULATION_Props.walk:
                bpy.context.scene.POPULATION_Props.ambient = False
            else:
                bpy.context.scene.POPULATION_Props.ambient = True
            init_previews(force=True, what = 'ANIM')
            bpy.context.scene.POPULATION_Props.inib = False

    def ambient_toggle(self, context):
        if not bpy.context.scene.POPULATION_Props.inib:
            bpy.context.scene.POPULATION_Props.inib =True
            if bpy.context.scene.POPULATION_Props.ambient:
                bpy.context.scene.POPULATION_Props.walk = False
            else:
                bpy.context.scene.POPULATION_Props.walk = True
            init_previews(force=True, what = 'ANIM')
            bpy.context.scene.POPULATION_Props.inib = False

    def refresh_people(self, context):
        init_previews(force=True, what = 'PERSO')

    def refresh_anim(self, context):
        init_previews(force=True, what = 'ANIM')

    def hd_toggle(self, context):
        if not bpy.context.scene.POPULATION_Props.inib:
            bpy.context.scene.POPULATION_Props.inib =True
            if bpy.context.scene.POPULATION_Props.hd:
                bpy.context.scene.POPULATION_Props.low = False
            else:
                bpy.context.scene.POPULATION_Props.low = True
            bpy.context.scene.POPULATION_Props.inib = False

    def low_toggle(self, context):
        if not bpy.context.scene.POPULATION_Props.inib:
            bpy.context.scene.POPULATION_Props.inib =True
            if bpy.context.scene.POPULATION_Props.low:
                bpy.context.scene.POPULATION_Props.hd = False
            else:
                bpy.context.scene.POPULATION_Props.hd = True
            bpy.context.scene.POPULATION_Props.inib = False

    inib: BoolProperty(
        name="toggle inibitor",
        default=False
    )

    single: BoolProperty(
        description="single people",
        name="Single people",
        default=True,
        update=single_toggle
    )
    crowd: BoolProperty(
        description="crowd",
        name="Crowd",
        default=False,
        update=crowd_toggle
    )
    walk: BoolProperty(
        description="People which follow path",
        name="Walk/Run",
        default=False,
        update=walk_toggle
    )
    ambient: BoolProperty(
        description="No path following",
        name="Ambiant",
        default=True,
        update=ambient_toggle
    )
########################################
    style_list:EnumProperty(
        name='Style',
        items=[
            ('casual','casual','casual'),
            ('sport','sport','sport'),
            ('business','business','business'),
        ],
        default='casual',
        update=refresh_people
    )
    hd: BoolProperty(
        description="high poly character",
        name="HD",
        default=False,
        update=hd_toggle
    )
    low: BoolProperty(
        description="lowpoly character",
        name="Lowpoly",
        default=True,
        update=low_toggle
    )
    anim_list: EnumProperty(
        name='Category',
        items=[
            ('communication', 'communication', 'communication'),
            ('dailylife', 'daily life', 'daily life'),
            ('dance', 'dance', 'dance'),
            ('walk', 'walk', 'walk'),
            ('working', 'working', 'working'),
            ('run', 'run', 'run'),
            ('sport', 'sport', 'sport')
        ],
        default='communication',
        update=refresh_anim
    )
    ##################
    crowd_list: CollectionProperty(type=CrowdItem)
    hidden_crowd_list: CollectionProperty(type=CrowdItem)
    ##################
    pre_pick_object: PointerProperty(type=bpy.types.Object)
    pre_pick_collection: PointerProperty(type=bpy.types.Collection)
    ##################
    randomize_color: BoolProperty(
        description="Randomize the color of models",
        name="Random color",
        default=True
    )
    ##################
    sub_instance: IntProperty(
        description="Number of sub instance. More increase to reduce the probability of animation synchronization.",
        name="Sub instance count",
        default=5
    )